/*******************************************************************************
* File Name: ALE.h  
* Version 1.70
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_ALE_H) /* Pins ALE_H */
#define CY_PINS_ALE_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "ALE_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_70 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 ALE__PORT == 15 && (ALE__MASK & 0xC0))

/***************************************
*        Function Prototypes             
***************************************/    

void    ALE_Write(uint8 value) ;
void    ALE_SetDriveMode(uint8 mode) ;
uint8   ALE_ReadDataReg(void) ;
uint8   ALE_Read(void) ;
uint8   ALE_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define ALE_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define ALE_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define ALE_DM_RES_UP          PIN_DM_RES_UP
#define ALE_DM_RES_DWN         PIN_DM_RES_DWN
#define ALE_DM_OD_LO           PIN_DM_OD_LO
#define ALE_DM_OD_HI           PIN_DM_OD_HI
#define ALE_DM_STRONG          PIN_DM_STRONG
#define ALE_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define ALE_MASK               ALE__MASK
#define ALE_SHIFT              ALE__SHIFT
#define ALE_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define ALE_PS                     (* (reg8 *) ALE__PS)
/* Data Register */
#define ALE_DR                     (* (reg8 *) ALE__DR)
/* Port Number */
#define ALE_PRT_NUM                (* (reg8 *) ALE__PRT) 
/* Connect to Analog Globals */                                                  
#define ALE_AG                     (* (reg8 *) ALE__AG)                       
/* Analog MUX bux enable */
#define ALE_AMUX                   (* (reg8 *) ALE__AMUX) 
/* Bidirectional Enable */                                                        
#define ALE_BIE                    (* (reg8 *) ALE__BIE)
/* Bit-mask for Aliased Register Access */
#define ALE_BIT_MASK               (* (reg8 *) ALE__BIT_MASK)
/* Bypass Enable */
#define ALE_BYP                    (* (reg8 *) ALE__BYP)
/* Port wide control signals */                                                   
#define ALE_CTL                    (* (reg8 *) ALE__CTL)
/* Drive Modes */
#define ALE_DM0                    (* (reg8 *) ALE__DM0) 
#define ALE_DM1                    (* (reg8 *) ALE__DM1)
#define ALE_DM2                    (* (reg8 *) ALE__DM2) 
/* Input Buffer Disable Override */
#define ALE_INP_DIS                (* (reg8 *) ALE__INP_DIS)
/* LCD Common or Segment Drive */
#define ALE_LCD_COM_SEG            (* (reg8 *) ALE__LCD_COM_SEG)
/* Enable Segment LCD */
#define ALE_LCD_EN                 (* (reg8 *) ALE__LCD_EN)
/* Slew Rate Control */
#define ALE_SLW                    (* (reg8 *) ALE__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define ALE_PRTDSI__CAPS_SEL       (* (reg8 *) ALE__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define ALE_PRTDSI__DBL_SYNC_IN    (* (reg8 *) ALE__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define ALE_PRTDSI__OE_SEL0        (* (reg8 *) ALE__PRTDSI__OE_SEL0) 
#define ALE_PRTDSI__OE_SEL1        (* (reg8 *) ALE__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define ALE_PRTDSI__OUT_SEL0       (* (reg8 *) ALE__PRTDSI__OUT_SEL0) 
#define ALE_PRTDSI__OUT_SEL1       (* (reg8 *) ALE__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define ALE_PRTDSI__SYNC_OUT       (* (reg8 *) ALE__PRTDSI__SYNC_OUT) 


#if defined(ALE__INTSTAT)  /* Interrupt Registers */

    #define ALE_INTSTAT                (* (reg8 *) ALE__INTSTAT)
    #define ALE_SNAP                   (* (reg8 *) ALE__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins ALE_H */

#endif
/* [] END OF FILE */
