/*******************************************************************************
* File Name: ISR_TI.h
* Version 1.50
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/
#if !defined(__ISR_TI_INTC_H__)
#define __ISR_TI_INTC_H__


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void ISR_TI_Start(void);
void ISR_TI_StartEx(cyisraddress address);
void ISR_TI_Stop(void) ;

CY_ISR_PROTO(ISR_TI_Interrupt);

void ISR_TI_SetVector(cyisraddress address) ;
cyisraddress ISR_TI_GetVector(void) ;

void ISR_TI_SetPriority(uint8 priority) ;
uint8 ISR_TI_GetPriority(void) ;

void ISR_TI_Enable(void) ;
uint8 ISR_TI_GetState(void) ;
void ISR_TI_Disable(void) ;

void ISR_TI_SetPending(void) ;
void ISR_TI_ClearPending(void) ;


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the ISR_TI ISR. */
#define ISR_TI_INTC_VECTOR            ((reg32 *) ISR_TI__INTC_VECT)

/* Address of the ISR_TI ISR priority. */
#define ISR_TI_INTC_PRIOR             ((reg8 *) ISR_TI__INTC_PRIOR_REG)

/* Priority of the ISR_TI interrupt. */
#define ISR_TI_INTC_PRIOR_NUMBER      ISR_TI__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable ISR_TI interrupt. */
#define ISR_TI_INTC_SET_EN            ((reg32 *) ISR_TI__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the ISR_TI interrupt. */
#define ISR_TI_INTC_CLR_EN            ((reg32 *) ISR_TI__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the ISR_TI interrupt state to pending. */
#define ISR_TI_INTC_SET_PD            ((reg32 *) ISR_TI__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the ISR_TI interrupt. */
#define ISR_TI_INTC_CLR_PD            ((reg32 *) ISR_TI__INTC_CLR_PD_REG)



/* __ISR_TI_INTC_H__ */
#endif
