/*******************************************************************************
* File Name: PSEN.h  
* Version 1.70
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_PSEN_H) /* Pins PSEN_H */
#define CY_PINS_PSEN_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "PSEN_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_70 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 PSEN__PORT == 15 && (PSEN__MASK & 0xC0))

/***************************************
*        Function Prototypes             
***************************************/    

void    PSEN_Write(uint8 value) ;
void    PSEN_SetDriveMode(uint8 mode) ;
uint8   PSEN_ReadDataReg(void) ;
uint8   PSEN_Read(void) ;
uint8   PSEN_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PSEN_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define PSEN_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define PSEN_DM_RES_UP          PIN_DM_RES_UP
#define PSEN_DM_RES_DWN         PIN_DM_RES_DWN
#define PSEN_DM_OD_LO           PIN_DM_OD_LO
#define PSEN_DM_OD_HI           PIN_DM_OD_HI
#define PSEN_DM_STRONG          PIN_DM_STRONG
#define PSEN_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define PSEN_MASK               PSEN__MASK
#define PSEN_SHIFT              PSEN__SHIFT
#define PSEN_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PSEN_PS                     (* (reg8 *) PSEN__PS)
/* Data Register */
#define PSEN_DR                     (* (reg8 *) PSEN__DR)
/* Port Number */
#define PSEN_PRT_NUM                (* (reg8 *) PSEN__PRT) 
/* Connect to Analog Globals */                                                  
#define PSEN_AG                     (* (reg8 *) PSEN__AG)                       
/* Analog MUX bux enable */
#define PSEN_AMUX                   (* (reg8 *) PSEN__AMUX) 
/* Bidirectional Enable */                                                        
#define PSEN_BIE                    (* (reg8 *) PSEN__BIE)
/* Bit-mask for Aliased Register Access */
#define PSEN_BIT_MASK               (* (reg8 *) PSEN__BIT_MASK)
/* Bypass Enable */
#define PSEN_BYP                    (* (reg8 *) PSEN__BYP)
/* Port wide control signals */                                                   
#define PSEN_CTL                    (* (reg8 *) PSEN__CTL)
/* Drive Modes */
#define PSEN_DM0                    (* (reg8 *) PSEN__DM0) 
#define PSEN_DM1                    (* (reg8 *) PSEN__DM1)
#define PSEN_DM2                    (* (reg8 *) PSEN__DM2) 
/* Input Buffer Disable Override */
#define PSEN_INP_DIS                (* (reg8 *) PSEN__INP_DIS)
/* LCD Common or Segment Drive */
#define PSEN_LCD_COM_SEG            (* (reg8 *) PSEN__LCD_COM_SEG)
/* Enable Segment LCD */
#define PSEN_LCD_EN                 (* (reg8 *) PSEN__LCD_EN)
/* Slew Rate Control */
#define PSEN_SLW                    (* (reg8 *) PSEN__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define PSEN_PRTDSI__CAPS_SEL       (* (reg8 *) PSEN__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define PSEN_PRTDSI__DBL_SYNC_IN    (* (reg8 *) PSEN__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define PSEN_PRTDSI__OE_SEL0        (* (reg8 *) PSEN__PRTDSI__OE_SEL0) 
#define PSEN_PRTDSI__OE_SEL1        (* (reg8 *) PSEN__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define PSEN_PRTDSI__OUT_SEL0       (* (reg8 *) PSEN__PRTDSI__OUT_SEL0) 
#define PSEN_PRTDSI__OUT_SEL1       (* (reg8 *) PSEN__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define PSEN_PRTDSI__SYNC_OUT       (* (reg8 *) PSEN__PRTDSI__SYNC_OUT) 


#if defined(PSEN__INTSTAT)  /* Interrupt Registers */

    #define PSEN_INTSTAT                (* (reg8 *) PSEN__INTSTAT)
    #define PSEN_SNAP                   (* (reg8 *) PSEN__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins PSEN_H */

#endif
/* [] END OF FILE */
