/*******************************************************************************
* File Name: Reset_int.h
* Version 1.60
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/
#if !defined(__Reset_int_INTC_H__)
#define __Reset_int_INTC_H__


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void Reset_int_Start(void);
void Reset_int_StartEx(cyisraddress address);
void Reset_int_Stop(void) ;

CY_ISR_PROTO(Reset_int_Interrupt);

void Reset_int_SetVector(cyisraddress address) ;
cyisraddress Reset_int_GetVector(void) ;

void Reset_int_SetPriority(uint8 priority) ;
uint8 Reset_int_GetPriority(void) ;

void Reset_int_Enable(void) ;
uint8 Reset_int_GetState(void) ;
void Reset_int_Disable(void) ;

void Reset_int_SetPending(void) ;
void Reset_int_ClearPending(void) ;


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the Reset_int ISR. */
#define Reset_int_INTC_VECTOR            ((reg32 *) Reset_int__INTC_VECT)

/* Address of the Reset_int ISR priority. */
#define Reset_int_INTC_PRIOR             ((reg8 *) Reset_int__INTC_PRIOR_REG)

/* Priority of the Reset_int interrupt. */
#define Reset_int_INTC_PRIOR_NUMBER      Reset_int__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable Reset_int interrupt. */
#define Reset_int_INTC_SET_EN            ((reg32 *) Reset_int__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the Reset_int interrupt. */
#define Reset_int_INTC_CLR_EN            ((reg32 *) Reset_int__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the Reset_int interrupt state to pending. */
#define Reset_int_INTC_SET_PD            ((reg32 *) Reset_int__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the Reset_int interrupt. */
#define Reset_int_INTC_CLR_PD            ((reg32 *) Reset_int__INTC_CLR_PD_REG)



/* __Reset_int_INTC_H__ */
#endif
