/*******************************************************************************
* File Name: byte_ready_ex.c  
* Version 1.70
*
* Description:
*  This file contains API to enable firmware to read the value of a Status 
*  Register.
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#include "byte_ready_ex.h"

#if !defined(byte_ready_ex_sts_sts_reg__REMOVED) /* Check for removal by optimization */


/*******************************************************************************
* Function Name: byte_ready_ex_Read
********************************************************************************
*
* Summary:
*  Reads the current value assigned to the Status Register.
*
* Parameters:
*  None.
*
* Return:
*  The current value in the Status Register.
*
*******************************************************************************/
uint8 byte_ready_ex_Read(void) 
{ 
    return byte_ready_ex_Status;
}


/*******************************************************************************
* Function Name: byte_ready_ex_InterruptEnable
********************************************************************************
*
* Summary:
*  Enables the Status Register interrupt.
*
* Parameters:
*  None.
*
* Return:
*  None.
*
*******************************************************************************/
void byte_ready_ex_InterruptEnable(void) 
{
    uint8 interruptState;
    interruptState = CyEnterCriticalSection();
    byte_ready_ex_Status_Aux_Ctrl |= byte_ready_ex_STATUS_INTR_ENBL;
    CyExitCriticalSection(interruptState);
}


/*******************************************************************************
* Function Name: byte_ready_ex_InterruptDisable
********************************************************************************
*
* Summary:
*  Disables the Status Register interrupt.
*
* Parameters:
*  None.
*
* Return:
*  None.
*
*******************************************************************************/
void byte_ready_ex_InterruptDisable(void) 
{
    uint8 interruptState;
    interruptState = CyEnterCriticalSection();
    byte_ready_ex_Status_Aux_Ctrl &= ~byte_ready_ex_STATUS_INTR_ENBL;
    CyExitCriticalSection(interruptState);
}


/*******************************************************************************
* Function Name: byte_ready_ex_WriteMask
********************************************************************************
*
* Summary:
*  Writes the current mask value assigned to the Status Register.
*
* Parameters:
*  mask:  Value to write into the mask register.
*
* Return:
*  None.
*
*******************************************************************************/
void byte_ready_ex_WriteMask(uint8 mask) 
{
    mask &= (1 << byte_ready_ex_INPUTS)-1;
    byte_ready_ex_Status_Mask = mask;
}


/*******************************************************************************
* Function Name: byte_ready_ex_ReadMask
********************************************************************************
*
* Summary:
*  Reads the current interrupt mask assigned to the Status Register.
*
* Parameters:
*  None.
*
* Return:
*  The value of the interrupt mask of the Status Register.
*
*******************************************************************************/
uint8 byte_ready_ex_ReadMask(void) 
{
    return byte_ready_ex_Status_Mask;
}

#endif /* End check for removal by optimization */


/* [] END OF FILE */
