/* ========================================
 * PC/DPTR implementation
 * ========================================
*/

#if !defined(COMB_DECOMP_H)
#define COMB_DECOMP_H

#include <device.h>

static inline uint8 decomp_low(uint16 two_byte)	// Program Counter decomposition from pc into pcl and pch
{
	uint8 low;
	
	low = two_byte & 0xFF;
	return low;
}

static inline uint8 decomp_high(uint16 two_byte)	// Program Counter decomposition from pc into pcl and pch
{
	uint8 high;
	
	high = (two_byte >> 8);
	return high;
}

static inline uint16 comb(uint8 high, uint8 low)		// Program Counter combination from pcl and pch into pc
{
	uint16 two_byte;
	
	two_byte = (high << 8) | low;
	return two_byte;
}

#endif
