/* ========================================
 * Special Function Register defines
 * and functions
 * ========================================
*/

#if !defined(SFR_H)
#define SFR_H

	#define P0		0x80
	#define SP		0x81
	#define DPL		0x82
	#define DPH		0x83
	
	#define PCON		0x87
	#define TCON		0x88
	#define TMOD		0x89
	#define TL0		0x8A
	#define TL1		0x8B
	#define TH0		0x8C
	#define TH1		0x8D
	
	#define P1		0x90
	#define SCON		0x98
	#define SBUF_TX	0x99
	#define SBUF_RX	0x9A
	
	#define PWM0_FH	0x9B		// 6.131 peripheral
	#define PWM0_FL	0x9C		// 6.131 peripheral
	#define PWM0_DH	0x9D		// 6.131 peripheral
	#define PWM0_DL	0x9E		// 6.131 peripheral
	#define PWM0_K		0x9F		// 6.131 peripheral
	
	#define P2		0xA0
	
	#define PH3_FH		0xA1		// 6.131 peripheral
	#define PH3_FL		0xA2		// 6.131 peripheral
	
	#define IE		0xA8
	
	#define P3		0xB0
	#define IP		0xB8
	#define ENP		0xC0
	#define PSW		0xD0
	#define ACC		0xE0
	#define B			0xF0
	
	/* BITS */
	
	#define AC		0xD6
	#define OV		0xD2
	#define IT0		0x88
	#define IE0		0x89
	#define IT1		0x8A
	#define IE1		0x8B
	#define TR0		0x8C
	#define TF0		0x8D
	#define TR1		0x8E
	#define TF1		0x8F
	
	#define Port1_0	0x90
	#define Port1_1	0x91
	#define Port1_2	0x92
	#define Port1_3	0x93
	#define Port1_4	0x94
	#define Port1_5	0x95
	#define Port1_6	0x96
	#define Port1_7	0x97
	
	#define RI		0x98
	#define TI		0x99
	#define REN		0x9C
	#define SM1		0x9E
	#define SM0		0x9F
	#define EX0		0xA8
	#define ET0		0xA9
	#define EX1		0xAA
	#define ET1		0xAB
	#define ES		0xAC
	#define EA		0xAF
	
	#define PX0		0xB8
	#define PT0		0xB9
	#define PX1		0xBA
	#define PT1		0xBB
	#define PS		0xBC
	
	#define PWM0_EN	0xC0		// 6.131 peripheral
	#define PH3_EN		0xC1		// 6.131 peripheral
	
	#define sp				InternalRAM[SP]
	#define cy				(InternalRAM[PSW] >> 7)
	#define current_Rbank 		((InternalRAM[PSW] >> 3) & 0b00000011)
	
#endif
	
	
	